/*
**	$Id: HotkeyPanel.c,v 1.7 92/08/15 20:12:46 olsen Sta Locker: olsen $
**	$Revision: 1.7 $
**	$Date: 92/08/15 20:12:46 $
**
**	Editing panel for hotkey configuration
**
**	Copyright  1990-1992 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_TERMTOFRONT,GAD_BUFFERTOFRONT,GAD_SKIP,GAD_ABORT_AREXX,GAD_PRIORITY,
		GAD_SOMEHOTKEYS,GAD_USE,GAD_LOAD,GAD_SAVE,GAD_CANCEL };

STATIC struct Gadget *
CreateAllGadgets(struct Hotkeys *Hotkeys,struct Gadget **GadgetArray,struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	LONG			 Counter = 0;

	SZ_SizeSetup(Screen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_HOTKEYPANEL_TERM_SCREEN_TO_FRONT_GAD,MSG_HOTKEYPANEL_HOTKEYS_ENABLED_GAD));

		SZ_ResetMaxWidth();

		if(SZ_Width(STRING_KIND,NULL,40,NULL) > 140)
			SZ_SetWidth(SZ_Width(STRING_KIND,NULL,40,NULL));
		else
			SZ_SetWidth(140);

		NewGadget . ng_GadgetText	= LocaleString(MSG_HOTKEYPANEL_TERM_SCREEN_TO_FRONT_GAD);
		NewGadget . ng_TextAttr		= &UserFont;
		NewGadget . ng_VisualInfo	= VisualInfo;
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Hotkeys -> termScreenToFront,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_HOTKEYPANEL_BUFFER_SCREEN_TO_FRONT_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Hotkeys -> BufferScreenToFront,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_HOTKEYPANEL_SKIP_DIAL_ENTRY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Hotkeys -> SkipDialEntry,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_HOTKEYPANEL_ABORT_AREXX_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	255,
			GTST_String,	Hotkeys -> AbortARexx,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		SZ_SetWidth(140);

		NewGadget . ng_GadgetText	= LocaleString(MSG_HOTKEYPANEL_COMMODITY_PRIORITY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,		'_',
			GTSL_Min,		-128,
			GTSL_Max,		127,
			GTSL_Level,		Hotkeys -> CommodityPriority,
			GTSL_LevelFormat,	"%4ld",
			GTSL_MaxLevelLen,	4,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_HOTKEYPANEL_HOTKEYS_ENABLED_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Hotkeys -> HotkeysEnabled,
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_LOAD_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_SAVE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_AlignBottom,	TRUE,
			SZ_GroupCount,	4,

			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_LOAD_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,

			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SAVE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,

			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_GroupNext,	TRUE,

			GT_Underscore,	'_',
		TAG_DONE);
	}

	return(Gadget);
}

BYTE
HotkeyPanel(struct Hotkeys *Hotkeys)
{
	struct Hotkeys		 PrivateHotkeys;
	struct Window		*PanelWindow;
	struct Gadget		*GadgetList = NULL;
	struct Gadget		*GadgetArray[GAD_CANCEL + 1];

	struct FileRequest	*FileRequest;
	UBYTE			 DummyBuffer[256],*DummyChar;

	CopyMem(Hotkeys,&PrivateHotkeys,sizeof(struct Hotkeys));

	if(CreateAllGadgets(Hotkeys,&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	(Screen -> Width	- SZ_GetWindowWidth())	/ 2,
			WA_Top,		(Screen -> Height	- SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Screen,

			WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_ACTIVEWINDOW | IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | STRINGIDCMP | SLIDERIDCMP | CHECKBOXIDCMP | BUTTONIDCMP,

			WA_Title,	LocaleString(MSG_HOTKEYPANEL_HOTKEY_PREFERENCES_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 Class,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			while(!Terminated)
			{
				WaitPort(PanelWindow -> UserPort);

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					Class	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					if(Class == IDCMP_VANILLAKEY)
						KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&Class,&Code);

					if(Class == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(Class == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(Class == IDCMP_CLOSEWINDOW)
					{
						CopyMem(&PrivateHotkeys,Hotkeys,sizeof(struct Hotkeys));

						Terminated = TRUE;
					}

					if(Class == IDCMP_MOUSEMOVE)
						Hotkeys -> CommodityPriority = (WORD)Code;

GadCheck:				if(Class == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_TERMTOFRONT:	strcpy(Hotkeys -> termScreenToFront,GT_STRING(Gadget));
										break;

							case GAD_BUFFERTOFRONT:	strcpy(Hotkeys -> BufferScreenToFront,GT_STRING(Gadget));
										break;

							case GAD_SKIP:		strcpy(Hotkeys -> SkipDialEntry,GT_STRING(Gadget));
										break;

							case GAD_ABORT_AREXX:	strcpy(Hotkeys -> AbortARexx,GT_STRING(Gadget));
										break;

							case GAD_LOAD:		strcpy(DummyBuffer,LastKeys);

										DummyChar = PathPart(DummyBuffer);

										*DummyChar = 0;

										BlockWindow(PanelWindow);

										if(FileRequest = GetFile(LocaleString(MSG_HOTKEYPANEL_LOAD_HOTKEYS_TXT),DummyBuffer,FilePart(LastKeys),DummyBuffer,"#?.prefs",FALSE,FALSE,FALSE,LocaleString(MSG_GLOBAL_LOAD_TXT)))
										{
											if(!LoadHotkeys(DummyBuffer,Hotkeys))
												MyEasyRequest(Window,LocaleString(MSG_HOTKEYPANEL_COULD_NOT_LOAD_HOTKEYS_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),DummyBuffer);
											else
											{
												strcpy(LastKeys,DummyBuffer);

												GT_SetGadgetAttrs(GadgetArray[GAD_TERMTOFRONT],PanelWindow,NULL,
													GTST_String,Hotkeys -> termScreenToFront,
												TAG_DONE);

												GT_SetGadgetAttrs(GadgetArray[GAD_BUFFERTOFRONT],PanelWindow,NULL,
													GTST_String,Hotkeys -> BufferScreenToFront,
												TAG_DONE);

												GT_SetGadgetAttrs(GadgetArray[GAD_SKIP],PanelWindow,NULL,
													GTST_String,Hotkeys -> SkipDialEntry,
												TAG_DONE);

												GT_SetGadgetAttrs(GadgetArray[GAD_ABORT_AREXX],PanelWindow,NULL,
													GTST_String,Hotkeys -> AbortARexx,
												TAG_DONE);

												GT_SetGadgetAttrs(GadgetArray[GAD_PRIORITY],PanelWindow,NULL,
													GTSL_Level,Hotkeys -> CommodityPriority,
												TAG_DONE);

												GT_SetGadgetAttrs(GadgetArray[GAD_PRIORITY],PanelWindow,NULL,
													GTCB_Checked,Hotkeys -> HotkeysEnabled,
												TAG_DONE);
											}
										}

										ReleaseWindow(PanelWindow);

										break;

							case GAD_SAVE:		strcpy(DummyBuffer,LastKeys);

										DummyChar = PathPart(DummyBuffer);

										*DummyChar = 0;

										BlockWindow(PanelWindow);

										Hotkeys -> HotkeysEnabled = GT_CHECKED(GadgetArray[GAD_SOMEHOTKEYS]);

										if(FileRequest = GetFile(LocaleString(MSG_HOTKEYPANEL_SAVE_HOTKEYS_TXT),DummyBuffer,FilePart(LastKeys),DummyBuffer,"#?.prefs",TRUE,FALSE,FALSE,LocaleString(MSG_GLOBAL_SAVE_TXT)))
										{
											if(!WriteIFFData(DummyBuffer,Hotkeys,sizeof(struct Hotkeys),'HOTK'))
												MyEasyRequest(Window,LocaleString(MSG_HOTKEYPANEL_COULD_NOT_SAVE_HOTKEYS_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),DummyBuffer);
											else
												strcpy(LastKeys,DummyBuffer);
										}

										ReleaseWindow(PanelWindow);

										break;

							case GAD_USE:		Terminated = TRUE;

										Hotkeys -> HotkeysEnabled = GT_CHECKED(GadgetArray[GAD_SOMEHOTKEYS]);

										break;

							case GAD_CANCEL:	Terminated = TRUE;

										CopyMem(&PrivateHotkeys,Hotkeys,sizeof(struct Hotkeys));

										break;

							default:		break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}
	}

	FreeGadgets(GadgetList);

	if(memcmp(&PrivateHotkeys,Hotkeys,sizeof(struct Hotkeys)))
		return(TRUE);
	else
		return(FALSE);
}
