/*
**	$Id: PreInclude.c,v 1.6 92/08/15 20:13:08 olsen Sta Locker: olsen $
**	$Revision: 1.6 $
**	$Date: 92/08/15 20:13:08 $
**
**	Definition file for precompiled header file
**
**	Copyright  1990-1992 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

	/* System includes (just a few). */

#include <intuition/intuitionbase.h>
#include <libraries/commodities.h>
#include <intuition/gadgetclass.h>
#include <libraries/translator.h>
#include <workbench/workbench.h>
#include <libraries/gadtools.h>
#include <libraries/iffparse.h>
#include <devices/inputevent.h>
#include <graphics/gfxmacros.h>
#include <devices/clipboard.h>
#include <intuition/sghooks.h>
#include <intuition/cghooks.h>
#include <devices/narrator.h>
#include <graphics/gfxbase.h>
#include <hardware/intbits.h>
#include <hardware/dmabits.h>
#include <hardware/custom.h>
#include <devices/console.h>
#include <devices/conunit.h>
#include <dos/filehandler.h>
#include <devices/serial.h>
#include <graphics/scale.h>
#include <dos/dosextens.h>
#include <libraries/asl.h>
#include <devices/audio.h>
#include <devices/input.h>
#include <devices/timer.h>
#include <exec/execbase.h>
#include <hardware/cia.h>
#include <utility/date.h>
#include <exec/devices.h>
#include <dos/datetime.h>
#include <dos/doshunks.h>
#include <clib/macros.h>
#include <exec/memory.h>
#include <rexx/rxslib.h>
#include <rexx/errors.h>
#include <dos/dostags.h>
#include <dos/rdargs.h>
#include <dos/dosasl.h>
#include <dos/var.h>

	/* Function prototypes. */

#include <clib/commodities_protos.h>
#include <clib/translator_protos.h>
#include <clib/rexxsyslib_protos.h>
#include <clib/intuition_protos.h>
#include <clib/graphics_protos.h>
#include <clib/gadtools_protos.h>
#include <clib/iffparse_protos.h>
#include <clib/diskfont_protos.h>
#include <clib/utility_protos.h>
#include <clib/layers_protos.h>
#include <clib/alib_protos.h>
#include <clib/icon_protos.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/asl_protos.h>
#include <clib/wb_protos.h>

	/* Include the following direct library interface definitions. */

#include <pragmas/utility.h>
#include <pragmas/timer.h>
#include <pragmas/exec.h>

	/* Standard `C' includes. */

#include <string.h>
#include <stdarg.h>
#include <stddef.h>

	/* Are we using the new includes? */

#ifdef ASLSM_FilterFunc

#include <libraries/locale.h>
#include <clib/locale_protos.h>

#endif	/* ASLSM_FilterFunc */

#include "termStrings.h"

	/* Special character codes. */

#define XOF '\21'
#define XON '\23'

#define BEL '\a'
#define VTB '\v'
#define TAB '\t'
#define BKS '\b'
#define ENT '\n'
#define RET '\r'
#define ESC '\033'
#define DEL '\177'
#define FFD '\f'
#define CAN '\030'
#define SUB '\032'
#define ENQ '\005'
#define SI  '\016'
#define SO  '\017'

	/* Internally handled control keys. */

#define CUP 150
#define CDN 151
#define CFW 152
#define CBK 153

#define FN1 128
#define FN2 129
#define FN3 130
#define FN4 131
#define FN5 132
#define FN6 133
#define FN7 134
#define FN8 135
#define FN9 136
#define F10 137

#define HLP 149

	/* Control sequence introducer. */

#define CSI 155

	/* Some #define values which may not yet be available in
	 * every include file set.
	 */

#ifndef GTMN_NewLookMenus
#define GTMN_NewLookMenus	(GT_TagBase+67)
#endif	/* GTMN_NewLookMenus */

#ifndef WA_NewLookMenus
#define WA_NewLookMenus		(WA_Dummy+0x30)
#endif	/* WA_NewLookMenus */

#ifndef GTCB_Scaled
#define GTCB_Scaled		GT_TagBase+68
#endif	/* GTCB_Scaled */

#ifndef GTMX_Scaled
#define GTMX_Scaled		GT_TagBase+69
#endif	/* GTMX_Scaled */

#ifndef SA_Interleaved
#define SA_Interleaved		(SA_Dummy + 0x0022)
#endif	/* SA_Interleaved */

	/* Use a simple address trick instead of the predefined
	 * address in amiga.lib.
	 */

#ifndef custom
#define custom (*(struct Custom *)0xDFF000)
#endif	/* custom */
